%global cvs_version 20090419cvs

Name:		tritonus
Summary:	Java Sound API Implementation
URL:		http://www.tritonus.org/
Group:		System Environment/Libraries
Version:	0.3.7
Release:	0.4.%{cvs_version}%{?dist}
License:	LGPLv2+
Source0:	%{name}-%{version}-%{cvs_version}.tar.bz2
Source9:	%{name}-snapshot.sh
# Remove lame and ioctl bits:
Patch0:		%{name}-configure.in.diff
# Make trinotus compile against the latest version of these libraries:
Patch1:		%{name}-src-lib-fluidsynth.Makefile.in.diff
Patch2:		%{name}-src-lib-alsa-Makefile.in.diff
Patch3:		%{name}-src-lib-alsa-constants_check.h.diff
Patch4:		%{name}-removed-code.diff
# Fix alsa midi crash RHBZ #510063
Patch5:		%{name}-src-lib-alsa-cast.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:	alsa-lib-devel
BuildRequires:	ant
BuildRequires:	cdparanoia-devel
BuildRequires:	esound-devel
BuildRequires:	fluidsynth-devel
BuildRequires:	java-devel >= 1.6
BuildRequires:	jorbis
BuildRequires:	jpackage-utils
BuildRequires:	libtool
BuildRequires:	libvorbis-devel
Requires:	java >= 1.6
Requires:	jpackage-utils
Requires:	jorbis

# The following circular dependencies are intentional. These classes need each other.
Requires:	%{name}-aos = %{version}-%{release}
Requires:	%{name}-core = %{version}-%{release}
Provides:	%{name}-shared = %{version}-%{release}

%description
Tritonus is an implementation of the Java Sound API. This package contains
common files and shared classes required by all other Tritonus plug-ins.


%package aos
Summary:	An add-on to the Java Sound API
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description aos
An add-on to the Java Sound API.

The AudioOutputStream architecture allow writing of audio data to audio files.
Supported types are .wav, .aiff and .au. It is an alternative to using 
AudioSystem.write(). The advantage over AudioSystem.write() is that with the
AudioOutputStream architecture, you can code your own main loop writing to the
audio file. The AudioOutputStream architecture implements a 'push' approach for
audio data, while AudioSystem.write() works with a "pull" approach. In many
situations, a 'push' approach is more flexible.

For an example of using the AudioOutputStream architecture, see the examples on
Java Sound Resources. There is an examples OscillatorFileAOS using the
AudioOutputStream architecture.

%package alsa
Summary:	ALSA based Implementations
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description alsa
Implementations of javax.sound.sampled.Mixer and javax.sound.midi.MidiDevice
based on ALSA.

It provides (most of) the capabilities of ALSA pcm and seq to Java Sound.
Especially, you can use this mixer to get full-duplex support and MIDI in/out
plus a very stable sequencer for Java Sound on Linux.

%package cdda
Summary:	A plug-in for Java that enables you to digitally read audio CD's
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description cdda
A plug-in for Java that enables you to digitally read audio CD's.

%package core
Summary:	Contains public classes and SPI instantiation support
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description core
This package Contains public classes and SPI instantiation support.

%package dsp
Summary:	A collection of classes for digital signal processing (DSP)
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description dsp
A collection of classes for digital signal processing (DSP).

For an example of how to use it, see AmplitudeConverter in the examples section
of the Java Sound Resources.

%package esd
Summary:	An implementation of javax.sound.sampled.Mixer based on libesd
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description esd
An implementation of javax.sound.sampled.Mixer based on libesd.

It provides (most of) the capabilities Esound provides to Java Sound. 
Especially, you can use this mixer to get full-duplex support for Java Sound on
Linux.

%package fluidsynth
Summary:	Plug-in for fluidsynth
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description fluidsynth
A tritonus plug-in for fluidsynth.

%package gsm
Summary:	GSM codec
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description gsm
For examples of using the GSM codec, refer to the Java Sound Resources examples
GSMEncoder, AudioDecoder and DecodingAudioPlayer:
http://www.jsresources.org/
http://www.jsresources.org/examples/GSMEncoder.html
http://www.jsresources.org/examples/AudioDecoder.html
http://www.jsresources.org/examples/DecodingAudioPlayer.html

%package javadoc
Summary:	Javadocs for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}
Requires:	jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%package javasequencer
Summary:	A Java-Sequencer
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description javasequencer
Note that for this sequencer to provide stable timing, three conditions have to
be met:

1. System.currentTimeMillis() has to do what its name says: It provides the
system time in milliseconds.

2. A synthesizer or MIDI port implementation that responds immediately.
Testing with the synthesizer of the Sun implementation resulted in horrible
timing. Timing with the hardware synthesizer of a SB Life!, accessed via ALSA,
was very good. Working with WireProvider should be ok, too (assuming you manage
to meet the first point)

3. Small scheduling latencies. On the GNU/Linux system that were tested, even
heavy file system traffic didn't lead to noticeable effects on the timing.

For testing with this sequencer, using a recent version of MidiPlayer from the
Java Sound Examples is recommended.

%package jorbis
Summary:	A plug-in for Java that enables decoding of Ogg Vorbis bitstreams
Group:		System Environment/Libraries
Requires:	jorbis
Requires:	%{name}-shared = %{version}-%{release}

%description jorbis
A plug-in for Java that enables decoding of Ogg Vorbis bitstreams. It is based
on the pure-java decoder implementation of JCraft. The decoder runs in
real-time even on old machines, as long as your Java runtime has a JIT-Compiler
(most contemporary have).

%package misc
Summary:	Plug-in with several service provider of Tritonus
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description misc
Plug-in with several service provider of Tritonus.

It contains the PCM2PCM converter, A-law and U-law converters, sample rate
converter, ADPCM converters, audio file readers and writers and MIDI file
readers and writers.

For an example of how to use the sample rate converter, see
SampleRateConverter.
http://www.jsresources.org/examples/SampleRateConverter.html

%package pvorbis
Summary:	Java plug-in that enables encoding to Ogg Vorbis bitstreams
Group:		System Environment/Libraries
Requires:	jorbis
Requires:	%{name}-shared = %{version}-%{release}

%description pvorbis
A plug-in for Java that enables encoding to Ogg Vorbis bitstreams.

%package src
Summary:	Sample rate converter
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description src
Sources for a Sample rate converter.

%package vorbis
Summary:	A plug-in for Java that enables encoding to Ogg Vorbis bitstreams
Group:		System Environment/Libraries
Requires:	%{name}-shared = %{version}-%{release}

%description vorbis
A plug-in for Java that enables encoding to Ogg Vorbis bitstreams. It is based
on the native vorbis libraries.


%prep
%setup -q
%patch0 -p1 -b .lameandioctl
%patch1 -p0 -b .oldapi
%patch2 -p0 -b .oldapi
%patch3 -p0 -b .oldapi
%patch4 -p1 -b .oldapi
%patch5 -p1 -b .cast

# Fix encoding issues
for file in doc/{compression.txt,TODO-matthias.txt,tritonusfaq.sgml}; do
	iconv -f iso-8859-1 -t utf8 $file > $file.tmp
	touch -r $file $file.tmp
	mv -f $file.tmp $file
done

# Remove classpath from manifest
sed -i '/Class-Path/d' build-common.xml

# Fix libdir issues
sed -i 's|/usr/lib|%{_libdir}|g' `find . -name Makefile.in`

# Fedora doesn't like usage of System.loadLibrary
sed -i 's|System.loadLibrary("\(.*\)")|System.load("%{_libdir}/%{name}/lib\1.so")|' `grep -rl loadLibrary *`

# Fix compiler flags
sed -i -e 's|-Werror||g' \
	-e 's|-Wl,-rpath,/home/matthias/java/tritonus/src/lib/common||g' \
	`find . -name Makefile.in`

# Prevent a rebuild in %%install
sed -i 's|install: all|install:|' Makefile.in

autoreconf -fi


%build
export CFLAGS="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/cdda"
export CPPFLAGS="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/cdda"
export CXXFLAGS="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/cdda"
%configure

%ant -f build-dtd.xml
# I don't know why these lines stop the building of tritonus:
sed -i -e '/timestampgranularity/d' -e '/serverlanguagecodeconfig/d' project.dtd

export CLASSPATH=`build-classpath jorbis`
%ant

make %{?_smp_mflags} JAVADIR=%{_jvmdir}/java

# javadoc doesn't want to process these two files:
rm -f src/classes/org/tritonus/debug/AJDebug*
%javadoc -d javadoc -public `find ./ -name '*.java'`


%install
rm -rf %{buildroot}

make install \
	LIBS="" \
	JAVAEXTPATH=%{buildroot}%{_libdir}/%{name} \
	JAVAEXTLIBPATH=%{buildroot}%{_libdir}/%{name} \
	DESTDIR=%{buildroot}

# jars
install -dm 755 %{buildroot}%{_libdir}/%{name}
install -pm 644 dist/*.jar %{buildroot}%{_libdir}/%{name}
pushd %{buildroot}%{_libdir}/%{name}
	for jar in *-%{version}*; do
		ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
	done
popd

# javadoc
install -dm 755 %{buildroot}%{_javadocdir}/%{name}
cp -pr javadoc/* %{buildroot}%{_javadocdir}/%{name}

# No need to have symlinks for JNI files
pushd %{buildroot}%{_libdir}/%{name}
	for sofile in *.so; do
		mv $sofile.1.0 $sofile
		rm -f $sofile.*
	done
popd

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc LGPL NEWS README doc/kaffe* doc/midi* doc/*TODO* doc/*proposal*
%dir %{_libdir}/%{name}/
%{_libdir}/%{name}/%{name}_share*.jar

%files alsa
%defattr(-,root,root,-)
%doc doc/ALSA* doc/Alsa* doc/bindists/alsa/readme.txt
%{_libdir}/%{name}/%{name}_alsa*.jar
%{_libdir}/%{name}/lib%{name}alsa.so

%files aos
%defattr(-,root,root,-)
%doc doc/AudioOutput*
%{_libdir}/%{name}/%{name}_aos*.jar

%files cdda
%defattr(-,root,root,-)
%doc doc/cdda.txt doc/bindists/cdda/readme.txt
%{_libdir}/%{name}/%{name}_cdda*.jar
%{_libdir}/%{name}/lib%{name}cdparanoia.so

%files core
%defattr(-,root,root,-)
%doc doc/%{name}faq.sgml
%{_libdir}/%{name}/%{name}_core*.jar

%files dsp
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{name}_dsp*.jar

%files esd
%defattr(-,root,root,-)
%doc doc/bindists/esd/readme.txt
%{_libdir}/%{name}/%{name}_esd*.jar
%{_libdir}/%{name}/lib%{name}esd.so

%files fluidsynth
%defattr(-,root,root,-)
%doc doc/fluidsynth*
%{_libdir}/%{name}/%{name}_fluidsynth*.jar
%{_libdir}/%{name}/lib%{name}fluid.so

%files gsm
%defattr(-,root,root,-)
%doc doc/compression*
%{_libdir}/%{name}/%{name}_gsm*.jar

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}

%files javasequencer
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{name}_javasequencer*.jar

%files jorbis
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{name}_jorbis*.jar

%files misc
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{name}_remaining*.jar

%files pvorbis
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{name}_pvorbis*.jar

%files src
%defattr(-,root,root,-)
%{_libdir}/%{name}/%{name}_src*.jar

%files vorbis
%defattr(-,root,root,-)
%doc doc/bindists/vorbis/readme.txt
%{_libdir}/%{name}/%{name}_vorbis*.jar
%{_libdir}/%{name}/lib%{name}vorbis.so

%changelog
* Wed Jul 08 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.4.20090419cvs
- Fix alsa midi crash RHBZ #510063
- No more rebuilding in %%install

* Fri May 29 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.3.20090419cvs
- Add disttag

* Thu May 07 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.2.20090419cvs
- Fix duplicate files issue

* Sun Apr 19 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.1.20090419cvs
- prepare the package for Fedora

* Thu Oct 16 2008 Alexander Kurtakov <akurtakov@mandriva.org> 0.3.7-0.0.cvs20080107.1mdv2009.1
+ Revision: 294485
- remove unneeded req
- really fix file list
- br libtool
- fix file list
- import tritonus
